--- gnome-netstatus-2.28.0.orig/src/wifi_info.c	1970-01-01 01:00:00.000000000 +0100
+++ gnome-netstatus-2.28.0/src/wifi_info.c	2009-09-25 11:46:40.212927446 +0100
@@ -0,0 +1,379 @@
+/*
+ * Simple test program, that takes a wireles device as an argument, and then
+ * tries to gather various configuration information from it.
+ */
+
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <unistd.h>
+#include <stropts.h>
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <fcntl.h>
+#include <inet/wifi_ioctl.h>
+#include <net/if_types.h>
+#include <net/if_dl.h> /*_link_ntoa*/
+
+#define TRUE   (1)
+#define FALSE  (0)
+
+#define DEV_PATH_PREFIX "/dev/"
+
+const int debug = 0;
+
+wldp_t  *gbuf = NULL;
+
+int 
+get_value( int fd, wldp_t *buf, int prop_id )
+{
+    int             rc;
+    struct strioctl stri;
+
+    (void) memset(gbuf, 0, MAX_BUF_LEN);
+
+    gbuf->wldp_type     =   NET_802_11;
+    gbuf->wldp_id       =   prop_id;
+    gbuf->wldp_length   =   sizeof( wldp_t );
+    stri.ic_timout      =   0;
+    stri.ic_dp          =   (char*)gbuf;
+    stri.ic_cmd         =   WLAN_GET_PARAM;
+    stri.ic_len         =   sizeof( wldp_t );
+
+    if ( (rc = ioctl( fd, I_STR, &stri )) != 0 ) {
+        if (debug) 
+            fprintf(stderr, "get_value( %d ): rc = %d\n", prop_id, rc);
+        return( -1 );
+    }
+    return( rc );
+}
+
+int
+is_connected( int fd ) 
+{
+    int rc;
+
+    if ( (rc = get_value( fd, gbuf, WL_LINKSTATUS )) != 0 ) {
+        if (debug) 
+            fprintf(stderr, "is_connected: rc = %d\n", rc);
+        return( -1 );
+    }
+
+    return((*(wl_linkstatus_t *)((gbuf)->wldp_buf) == WL_CONNECTED));
+}
+
+int
+is_wifi( int fd ) 
+{
+    return( (get_value(fd, gbuf, WL_BSS_TYPE ) < 0 )?FALSE:TRUE );
+}
+
+int
+get_signal_strength( int fd ) 
+{
+    int             rc;
+
+    if ( (rc = get_value( fd, gbuf, WL_RSSI )) != 0 ) {
+        if (debug) 
+            fprintf(stderr, "get_signal_strength: rc = %d\n", rc);
+        return( -1 );
+    }
+
+    return( *(wl_rssi_t *)(gbuf->wldp_buf) ); // Get Signal Value
+}
+
+char*
+get_essid( int fd ) 
+{
+    char           *str;
+    int             rc;
+
+    str = calloc(256,sizeof(char));
+
+    if ( (rc = get_value( fd, gbuf, WL_ESSID )) != 0 ) {
+        if (debug) 
+            fprintf(stderr, "get_essid: rc = %d\n", rc);
+        return( str );
+    }
+
+    // Get ESSID Value
+    (void) strlcpy(str, ((wl_essid_t*)(gbuf->wldp_buf))->wl_essid_essid, 256);
+    return( str ); 
+}
+
+extern char *_link_ntoa(const unsigned char *, char *, int, int);
+
+char*
+get_bssid( int fd ) 
+{
+    char           *str;
+    int             rc;
+
+    str = calloc(256,sizeof(char));
+
+    if ( (rc = get_value( fd, gbuf, WL_BSSID )) != 0 ) {
+        if (debug) 
+            fprintf(stderr, "get_bssid: rc = %d\n", rc);
+        return( str );
+    }
+
+    // Get BSSID Value
+	_link_ntoa((const unsigned char*)gbuf->wldp_buf, str, 6, IFT_OTHER);
+
+    return( str ); 
+}
+
+const char*
+get_bss_mode( int fd ) 
+{
+    const char     *str;
+    int             rc;
+    wl_bss_type_t   bsstype;
+
+    str = "";
+
+    if ( (rc = get_value( fd, gbuf, WL_BSS_TYPE )) != 0 ) {
+        if (debug) 
+            fprintf(stderr, "get_bss_mode: rc = %d\n", rc);
+        return( str );
+    }
+
+    // Get BSS Type Value
+    bsstype = *(wl_bss_type_t *)(gbuf->wldp_buf);
+
+	switch (bsstype) {
+	case WL_BSS_BSS:
+		str = "bss";
+		break;
+	case WL_BSS_IBSS:
+		str = "ibss";
+		break;
+	case WL_BSS_ANY:
+		str = "any";
+		break;
+	default:
+		break;
+	}
+
+    return( str ); 
+}
+
+const char*
+get_encryption( int fd ) 
+{
+    char           *str = "none";
+    int             rc;
+	wl_encryption_t	encryption;
+
+    if ( (rc = get_value( fd, gbuf, WL_ENCRYPTION )) != 0 ) {
+        if (debug) 
+            fprintf(stderr, "get_encryption: rc = %d\n", rc);
+
+        return( str );
+    }
+
+	encryption = *(wl_encryption_t *)(gbuf->wldp_buf);
+
+	switch (encryption) {
+	case WL_ENC_WEP:
+		str = "wep";
+		break;
+	case WL_ENC_WPA:
+		str = "wpa";
+		break;
+	case WL_NOENCRYPTION:
+        /* fall-through */
+	default:
+		/* already default = none */
+		break;
+	}
+
+    return( str ); 
+}
+
+const char*
+get_auth_mode( int fd ) 
+{
+    char           *str = "open";
+    int             rc;
+	wl_authmode_t	authmode;
+
+    if ( (rc = get_value( fd, gbuf, WL_AUTH_MODE )) != 0 ) {
+        if (debug) 
+            fprintf(stderr, "get_authmode: rc = %d\n", rc);
+
+        return( str );
+    }
+
+	authmode = *(wl_authmode_t *)(gbuf->wldp_buf);
+
+	switch (authmode) {
+	case WL_SHAREDKEY:
+		str = "shared";
+		break;
+	case WL_OPENSYSTEM:
+        /* fall-through */
+	default:
+		/* already default = open */
+		break;
+	}
+
+    return( str ); 
+}
+
+
+const char*
+get_mode( int fd ) 
+{
+    char           *str = "";
+    int             rc;
+	wl_phy_conf_t  *phy_conf;
+
+    if ( (rc = get_value( fd, gbuf, WL_PHY_CONFIG )) != 0 ) {
+        if (debug) 
+            fprintf(stderr, "get_mode: rc = %d\n", rc);
+
+        return( str );
+    }
+
+    phy_conf = (wl_phy_conf_t *)(gbuf->wldp_buf);
+
+	switch (phy_conf->wl_phy_fhss_conf.wl_fhss_subtype) {
+	case WL_ERP:
+		str = "g";
+        break;
+	case WL_OFDM:
+		str = "a";
+        break;
+	case WL_DSSS:
+	case WL_FHSS:
+		str = "b";
+        break;
+	default:
+		break;
+	}
+
+	return (str);
+}
+
+int
+handle_dev( const char* dev ) 
+{
+    char         *devpath       = NULL;
+    int           fd            = -1;
+    int           iswifi        = FALSE;
+    int           isconnected   = FALSE;
+    char         *essid         = NULL;
+    char         *bssid         = NULL;
+    const char   *bss_mode      = NULL;
+    const char   *mode          = NULL;
+    const char   *auth_mode     = NULL;
+    const char   *encryption    = NULL;
+    int           signal        = 0;
+    const char   *dev_no_path   = NULL;
+
+    if ( dev == NULL ) {
+        return( 1 );
+    }
+
+    if ( (dev_no_path = strchr(dev, '/')) == NULL ) {
+        /* Prefix with /dev/net/ */
+        int buflen = strlen(DEV_PATH_PREFIX) + strlen(dev) + 2;
+
+        devpath = malloc( buflen );
+        (void)snprintf(devpath, buflen, "%s%s", DEV_PATH_PREFIX, dev );
+
+        dev_no_path = dev;  /* Pass back what was used as arg */
+    }
+    else {
+        devpath = strdup( dev );
+        dev_no_path++; /* Skip '/' */
+    }
+
+    if ( (fd = open( devpath, O_RDONLY )) < 0 ) {
+        if ( debug )
+            fprintf(stderr,"Unable to open dev %s\n", dev);
+        /* Output something so caller doesn't block waiting for response */
+        printf("%s;%d;%d;%s;%d;%s;%s;%s;%s\n", 
+               dev_no_path, 
+               iswifi?TRUE:FALSE, 
+               isconnected?TRUE:FALSE, 
+               essid?essid:"", 
+               signal,
+               mode?mode:"", 
+               bssid?bssid:"", 
+               encryption?encryption:"", 
+               auth_mode?auth_mode:""
+               );
+        fflush(stdout);
+        free(devpath);
+        return (1);
+    }
+    
+    iswifi = is_wifi(fd);
+    isconnected = is_connected(fd);
+     
+    if ( iswifi && isconnected ) {
+
+        essid = get_essid(fd);
+        bssid = get_bssid(fd);
+        bss_mode = get_bss_mode(fd);
+        mode = get_mode(fd);
+        auth_mode = get_auth_mode(fd);
+        encryption = get_encryption(fd);
+        signal = get_signal_strength(fd);
+
+    }
+
+    printf("%s;%d;%d;%s;%d;%s;%s;%s;%s;%s\n", 
+           dev_no_path, 
+           iswifi?TRUE:FALSE, 
+           isconnected?TRUE:FALSE, 
+           essid?essid:"", 
+           signal,
+           mode?mode:"", 
+           bssid?bssid:"", 
+           bss_mode?bss_mode:"", 
+           encryption?encryption:"", 
+           auth_mode?auth_mode:""
+           );
+
+    fflush(stdout);
+
+    close(fd);
+
+    free(devpath);
+
+    if ( essid != NULL ) {
+        free(essid);
+        free(bssid);
+    }
+
+    return(0);
+}
+
+int
+main( int argc, char* argv[] ) 
+{
+    char    stdin_buffer[MAXPATHLEN];
+
+    if ((gbuf = malloc(MAX_BUF_LEN)) == NULL) {
+        return (1);
+    }
+
+
+    setbuf(stdin, NULL );
+
+    while ( fgets( stdin_buffer, MAXPATHLEN, stdin ) != NULL ) {
+        char *eol = strrchr( stdin_buffer, '\n' );
+        if ( eol != NULL ) 
+            *eol = '\0';
+
+        handle_dev( stdin_buffer );
+    }
+
+    free(gbuf);
+
+    return(0);
+}
diff -up ./configure.in.clean ./configure.in
--- ./configure.in.clean	2009-10-20 08:28:14.709772269 +0100
+++ ./configure.in	2009-10-13 09:20:07.258434585 +0100
@@ -49,6 +49,11 @@ PKG_CHECK_MODULES(NETSTATUS,
 
 AC_CHECK_HEADERS(sys/sockio.h)
 
+dnl *** checks for socket, nsl and scf libraries ***
+AC_CHECK_FUNC(socket,,[AC_CHECK_LIB(socket,socket)])
+AC_CHECK_FUNC(gethostbyname,,[AC_CHECK_LIB(nsl,gethostbyname)])
+AC_CHECK_FUNC(smf_get_state,,[AC_CHECK_LIB(scf,smf_get_state)])
+
 # Blatantly stolen from configure.in in the sample code from
 # "UNIX Network Programming, Volume 1" by W. Richard Stevens
 AC_CACHE_CHECK(if sockaddr has sa_len member,
@@ -118,6 +123,16 @@ Makefile
 po/Makefile.in
 src/Makefile
 icons/Makefile
+icons/hicolor/Makefile
+icons/hicolor/24x24/Makefile
+icons/hicolor/24x24/status/Makefile
+icons/hicolor/24x24/emblems/Makefile
+icons/hicolor/scalable/status/Makefile
+icons/hicolor/scalable/Makefile
+icons/hicolor/scalable/emblems/Makefile
+icons/hicolor/32x32/status/Makefile
+icons/hicolor/32x32/emblems/Makefile
+icons/hicolor/32x32/Makefile
 help/Makefile
 help/ja/Makefile
 help/ko/Makefile

--- gnome-netstatus-2.28.0.orig/src/Makefile.am	2009-09-25 11:46:34.296413697 +0100
+++ gnome-netstatus-2.28.0/src/Makefile.am	2009-09-25 11:46:40.213683924 +0100
@@ -8,11 +8,14 @@
 	$(NETSTATUS_CFLAGS) \
 	$(NETSTATUS_DEBUG_CFLAGS) \
 	$(WARN_CFLAGS) \
-	-DNETSTATUS_ICONDIR=\""$(datadir)/icons/gnome-netstatus\"" \
+	-DNETSTATUS_DATA_DIR=\""$(pkgdatadir)\"" \
 	-DNETSTATUS_BUILDERDIR=\""$(builderdir)\"" \
 	-DGNOMELOCALEDIR=\""$(prefix)/$(DATADIRNAME)/locale"\"
 
-libexec_PROGRAMS = gnome-netstatus-applet
+libexec_PROGRAMS = gnome-netstatus-applet gnome-netstatus-wifi-info
+
+gnome_netstatus_wifi_info_SOURCES = \
+	wifi_info.c
 
 gnome_netstatus_applet_LDADD = $(NETSTATUS_LIBS) $(KSTAT_LIBS)
 
--- gnome-netstatus-2.28.0.orig/src/netstatus-sysdeps.c	2009-09-25 13:20:00.177042518 +0100
+++ gnome-netstatus-2.28.0/src/netstatus-sysdeps.c	2009-09-25 13:25:09.054558210 +0100
@@ -442,23 +442,178 @@
   return NULL;
 }
 
+typedef struct {
+  gboolean      started;
+  GPid          pid;
+  gint          standard_input;
+  gint          standard_output;
+  gint          standard_error;
+  FILE*         in;
+  FILE*         out; 
+  FILE*         err;
+} child_info_t;
+
+static child_info_t child_info = { FALSE, 0, -1, -1, -1, NULL, NULL, NULL };
+
+static void
+child_watch_func( GPid pid, gint status, gpointer data)
+ {
+    child_info_t* info = (child_info_t*)data;
+
+    g_return_if_fail( info != NULL );
+
+    fclose( info->in );
+    fclose( info->out );
+    fclose( info->err );
+
+    memset( info, 0, sizeof( child_info_t ) );
+
+    info->started = FALSE;
+}
+
 char *
-netstatus_sysdeps_read_iface_wireless_details (const char *iface,
-					       gboolean   *is_wireless,
-					       int        *signal_strength)
+read_wireless_info( const char *iface ) {
+  static  char         *child_argv[] = { 
+                                  "/usr/bin/pfexec",
+                                  "/usr/lib/gnome-netstatus-wifi-info",
+                                  NULL
+                               };
+
+  if ( iface == NULL ) {
+    return ( NULL );
+  }
+
+  if ( ! child_info.started ) {
+    child_info.started = g_spawn_async_with_pipes( NULL, child_argv, NULL, G_SPAWN_DO_NOT_REAP_CHILD, NULL, 
+                                                   NULL, &child_info.pid, &child_info.standard_input, 
+                                                   &child_info.standard_output, &child_info.standard_error, NULL);
+
+    if ( child_info.started ) {
+      g_child_watch_add(child_info.pid, child_watch_func, &child_info);
+      child_info.in = fdopen( child_info.standard_input, "w");
+      setbuf(child_info.in, NULL);
+      child_info.out = fdopen( child_info.standard_output, "r");
+      setbuf(child_info.out, NULL);
+      child_info.err = fdopen( child_info.standard_error, "r");
+      setbuf(child_info.err, NULL);
+    }
+  }
+
+  if ( child_info.started ) {
+    char buf[1024];
+    int  n;
+
+    fprintf( child_info.in, "%s\n", iface );
+
+    if ( fgets( buf, 1024, child_info.out ) == NULL ) {
+      return(NULL);
+    }
+
+    return( g_strdup( buf ) );
+  }
+
+  return (NULL);
+}
+
+wifi_info_t* 
+netstatus_wifi_info_new(   char       *essid,
+                           gboolean    connected,
+                           char       *bssid,
+                           char       *bss_mode,
+                           int         signal_strength,
+                           char       *mode,
+                           char       *security,
+                           char       *auth_mode )
 {
-  g_return_val_if_fail (iface != NULL, NULL);
-  g_return_val_if_fail (is_wireless != NULL, NULL);
-  g_return_val_if_fail (signal_strength != NULL, NULL);
-                                                                                
-  if (is_wireless)
-    *is_wireless = FALSE;
-  if (signal_strength)
-    *signal_strength = 0;
-                                                                                
-  return NULL;
+    wifi_info_t* wi = g_new0( wifi_info_t, 1 );
+
+    wi->essid = g_strdup(essid?essid:"");
+    wi->connected = connected;
+    wi->bssid = g_strdup(bssid?bssid:"");
+    wi->bss_mode = g_strdup(bss_mode?bss_mode:"");
+    wi->signal_strength = signal_strength;
+    wi->mode = g_strdup(mode?mode:"");
+    wi->security = g_strdup(security?security:"");
+    wi->auth_mode = g_strdup(auth_mode?auth_mode:"");
+   
+    return( wi );
+}
+
+void
+netstatus_wifi_info_free( wifi_info_t * wi )
+{
+    g_return_if_fail( wi != NULL );
+
+    if ( wi->essid )
+        g_free(wi->essid);
+    if ( wi->bssid )
+        g_free(wi->bssid);
+    if ( wi->bss_mode )
+        g_free(wi->bss_mode);
+    if ( wi->mode )
+        g_free(wi->mode);
+    if ( wi->security )
+        g_free(wi->security);
+    if ( wi->auth_mode )
+        g_free(wi->auth_mode);
+
+    g_free(wi);
 }
 
+wifi_info_t *
+netstatus_sysdeps_read_iface_wireless_details (const char *iface)
+{
+  gchar*        str = NULL;
+  wifi_info_t  *wi = NULL;
+  gboolean      is_wireless = FALSE;
+
+   g_return_val_if_fail (iface != NULL, NULL);
+
+  if ( (str = read_wireless_info( iface )) == NULL ) {
+    /* Not wireless, return NULL */
+    return NULL;
+  }
+  else {
+    gchar** fields = g_strsplit_set( g_strchomp(str), ";", 10 );
+
+    is_wireless = (fields[1] != NULL && fields[1][0] == '1')?TRUE:FALSE;
+
+    if ( is_wireless ) {
+      gboolean  connected = (fields[2] != NULL && fields[2][0] == '1')?TRUE:FALSE;
+      char     *essid = fields[3];
+      int       signal_strength = (fields[4] != NULL)?atoi(fields[4]):0;
+      char     *mode = fields[5];
+      char     *bssid = fields[6];
+      char     *bss_mode = fields[7];
+      char     *security = fields[8];
+      char     *auth_mode = fields[9];
+
+      /* Using the Linux code above, log() will provide a smoother
+       * transition between signal strengths than simple division */
+      /* *signal_strength = ((*signal_strength * 100) / 15 ); */
+      signal_strength = (int) rint ((log (signal_strength) / log (15)) * 100.0);
+      signal_strength = CLAMP( signal_strength, 0, 100);
+
+      wi = netstatus_wifi_info_new( essid,
+                                    connected,
+                                    bssid,
+                                    bss_mode,
+                                    signal_strength,
+                                    mode,
+                                    security,
+                                    auth_mode );
+
+    }
+
+    if ( fields != NULL ) 
+        g_strfreev(fields);
+
+    g_free( str );
+  }
+                                                                                  
+  return wi;
+ }
+
 #else /* defined(__FreeBSD__) */
 
 static inline void
